(function($) {
    $.gamesRegistry('register', 'kg', new (function() {

        var options = {
            'view_width': Infinity,
            'view_height': Infinity,
            'view_background_img': ''
        };

        var game = this;

        this.getPrototypeWidth = function(number) {
            return parseFloat(
                    $('#playground #prototype_num_' + number)[0].style.width
                    );

        };

        this.playSound = function(ok) 
        {
            if ($('.sound.button.off').length === 1) {
                return;
            }
            var sound;

            if (ok) {
                var soundId = Math.floor(Math.random() * options.ok_sounds.length);
                sound = options.ok_sounds[soundId];
            } else {
                var soundId = Math.floor(Math.random() * options.fail_sounds.length);
                sound = options.fail_sounds[soundId];
            }

            if (snd_instance !== undefined) {
                snd_instance.pause();
            }

            if (this.characterSound) {
                this.characterSound.stop();
            }

            this.characterSound = createjs.Sound.play(sound, createjs.Sound.INTERUPT_LATE);
            this.characterSound.addEventListener("complete", function() {
                if (snd_instance !== undefined) {
                    snd_instance.resume();
                }
            });
        };

        this.inArray = function in_array(array, id) {
            for (var i = 0; i < array.length; i++) {
                if (array[i] === id) {
                    return true;
                }
            }
            return false;
        };

        this.shuffle = function(o) {
            for (var j, x, i = o.length; i; j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x)
                ;
            return o;
        };

        this.makeDraggable = function(obj) {
            obj.draggable({
                revert: true,
                start: function() {
                    $(this).addClass('drag-now');
                },
                stop: function() {
                    $(this).removeClass('drag-now');
                }
            });

        };

        this.getObjectNumber = function(number) {
            var $operandContainer = $('<div>');
            $operandContainer.attr('title', number + 'dkg');
            $operandContainer
                    .addClass('container-big-number')
                    .addClass('container-big-number-dkg')
                    .addClass('eq');

            var numberAsArray = new Array();

            while (number !== 0) {
                lastNumber = number % 10;
                numberWithoutLastNumber = number - lastNumber;
                numberAsArray.push(lastNumber);
                number = Math.floor(number / 10);
            }

            numberAsArray.reverse();
            var $number = new Array();

            for (var i = 0; i < numberAsArray.length; i++) {
                $number[i] = $('#playground #prototype_num_' + numberAsArray[i]).clone();
                smallerWidth = parseFloat($number[i].css('width')) / 3;
                smallerHeight = parseFloat($number[i].css('height')) / 3;

                $number[i]
                        .addClass('eq')
                        .css('width', smallerWidth + '%')
                        .css('height', smallerHeight + '%');
            }

            $dkg = $('#playground #prototype_dkg').clone();
            $dkg.addClass('eq');

            leftPosition = 0;
            if (numberAsArray.length === 1) {
                leftPosition = 16;
            }

            for (var i = 0; i < numberAsArray.length; i++) {
                $number[i].css('left', leftPosition + '%');
                $operandContainer.append($number[i]);
                leftPosition += 25;
            }

            leftPosition -= 2;

            $operandContainer.append($dkg);
            $dkg.css({
                'left': leftPosition + '%'
            });

            return $operandContainer;
        };

        this.randomEq = function() {
            var that = this;

            var operandFirst = 0;

            while (operandFirst === 0) {
                operandFirst = parseInt(Math.random() * 98 + 1);
            }

            var operandSecond = 100 - operandFirst;
            var result = 100;

            $placeClone = $('#playground #prototype_place_long').clone();
            $placeClone.addClass('eq').hide();

            $operandFirst = that.getObjectNumber(operandFirst);
            $operandFirst.css('left', '20%').hide();

            $resultHide = that.getObjectNumber(operandSecond);
            $resultHide
                    .attr('id', 'result')
                    .css({
                'width': '22%',
                'top': '15%',
                'left': '51%',
                'opacity': '0'
            }).hide();

            $placeClone
                    .css('width', '18%')
                    .css('top', '13%')
                    .css('left', '50%');

            $('#playground').append([
                $operandFirst,
                $resultHide,
                $placeClone
            ]);

            $('.eq').fadeIn();

            $placeClone.droppable({
                accept: '.answer',
                drop: function(event, ui) {

                    if (ui.draggable.hasClass('correct')) {
                        ui.draggable.hide();
                        $('.refresh.button').unbind('click');

                        $('#result').css('opacity', 1);
                        $(this).css('background', 'none');

                        that.playSound(true);

                        $('#playground .eq').fadeOut(1500);

                        setTimeout(function() {
                            $('#playground .eq').remove();
                            game.randomEq();
                        }, 2000);

                        $('#IMG_chlopak_ok').fadeIn('fast', function() {
                            setTimeout("$('#IMG_chlopak_ok').fadeOut('fast')", 500);
                        });
                    } else {
                        game.playSound(false);

                        $('#IMG_chlopak_bad').fadeIn('fast', function() {
                            setTimeout("$('#IMG_chlopak_bad').fadeOut('fast')", 500);
                        });
                    }
                    
                    return false;
                }

            });

            var chooser = new Array();
            chooser.push(operandSecond);

            for (var i = 0; i < 2; i++) {
                var n = Math.floor((Math.random() * 98) + 1);

                if (n !== result && !this.inArray(chooser, n)) {
                    chooser.push(n);
                } else {
                    i -= 1;
                }
            }

            this.shuffle(chooser);

            var marginLeft = 8;
            var marginTop = 43;

            $.each(chooser, function(key, val) {
                $numCl = that.getObjectNumber(val);
                $numCl.addClass('eq').addClass('response-option');
                $numCl.attr('id', 'ch-' + val);
                $numCl.css('top', marginTop + '%');
                $numCl.css('left', marginLeft + '%');
                marginLeft += 25;

                $('#playground').append($numCl);
                that.makeDraggable($numCl);
                $numCl.addClass('answer');

                if (val === operandSecond) {
                    $numCl.addClass('correct');
                }
            });

            $('.eq').fadeIn(500);
            setTimeout(function(){
                $('.refresh.button').unbind('click').bind('click', function() {
                    if (that.characterSound !== undefined) {
                        that.characterSound.stop();
                    }
                    
                    restartPrompt(function(){
                        goToStartPage();
                    });
                });
            }, 500);
        };

        this.createObj = function(data) {

            var obj = $('<div class="object"></div>');

            obj.css('background-image', 'url("' + preload.getResult(data.image).src + '")');

            obj.width(100 * data.width / options.view_width + '%');
            obj.height(100 * data.height / options.view_height + '%');
            obj.css({
                left: 100 * data.x / options.view_width + '%',
                top: 100 * data.y / options.view_height + '%'
            });

            if (data['visible'] !== undefined && data['visible'] === false) {
                obj.css('display', 'none');
                obj.attr('id', data.image);
            }

            return obj;
        };

        this.init = function(data) {
            $.extend(options, data);
            var that = this;

            var background = preload.getResult(options.view_background_img).src;
            $('#playground').css('background-image', 'url("' + background + '")');

            $.each(options.prototypes, function(key, val) {
                var o = that.createObj(this);
                o.css('display', 'none');
                o.attr('id', 'prototype_' + key);

                if (key === 'dkg') {
                    o.addClass('dkg');
                }
                if (key === 'place_long') {
                    o.addClass('place_long');
                }

                $('#playground').append(o);
            });

            this.placeWidth = parseFloat($('#prototype_place_long')[0].style.width);

            $.each(options.objects, function() {
                $('#playground').append(that.createObj(this));
            });
            
            $('#IMG_chlopak_ok').css('z-index', 9);
            $('#IMG_chlopak_bad').css('z-index', 10);

            that.randomEq();

            $('.sound.button').bind('click', function() {
                if ($('.sound.button.off').length === 1 && that.characterSound !== undefined) {
                    that.characterSound.stop();
                }
            });

        };
    })());
})(jQuery);

